var last_emails = [];

function mailcatch_insert_random(node)
{
	var chars = "0123456789abcdefghiklmnopqrstuvwxyz";
	var string_length = 16;
	var emailprefix = '';
	for (var i = 0; i < string_length; i++)
	{
		var rnum = Math.floor(Math.random() * chars.length);
		emailprefix += chars.substring(rnum,rnum+1);
	}

	var email = emailprefix + "@mailcatch.com";
	node.value = email;

	// Insert it into the last used emails
	last_emails.unshift({
		email:email,
		prefix:emailprefix,
		used_on:[window._content.document.location],
	});

	if (last_emails.length > 5) last_emails.pop();
	mailcatch_regenerate_last();
}

function mailcatch_insert_specific(node, email)
{
	node.value = email;
	for (i = 0; i < last_emails.length; i++)
	{
		if (last_emails[i].email == email)
		{
			var unfound = true;
			for (j = 0; j < last_emails[i].used_on.length; j++)
			{
				if (last_emails[i].used_on[j] == window._content.document.location) unfound = false;
			}
			if (unfound) last_emails[i].used_on.push(window._content.document.location);
		}
	}
	mailcatch_regenerate_last();
}

function mailcatch_regenerate_last()
{
	var container = document.getElementById("mailcatch_last_emails");
	if (last_emails.length > 0) container.hidden = false;

	container = document.getElementById("mailcatch_last_emails_popup");

	// Remove all of the existing buttons
	for(i=container.childNodes.length; i > 0; i--) {
		container.removeChild(container.childNodes[0]);
	}

	for (i = 0; i < last_emails.length; i++)
	{
		var email = last_emails[i].email;
		var prefix = last_emails[i].prefix;
		var menu = document.createElement("menu");
		menu.setAttribute("label", email);
		container.appendChild(menu);

		var menupopup = document.createElement("menupopup");
		menu.appendChild(menupopup);

		var menuinsert = document.createElement("menuitem");
		menuinsert.setAttribute("label", "Insert Here");
		menuinsert.setAttribute("accesskey", "I");
		menuinsert.setAttribute("oncommand", 'mailcatch_insert_specific(document.popupNode,"'+email+'")');
		menupopup.appendChild(menuinsert);

		var menugo = document.createElement("menuitem");
		menugo.setAttribute("label", "Check inbox");
		menugo.setAttribute("accesskey", "C");
		menugo.setAttribute("oncommand", 'mailcatch_loadurl("http://mailcatch.com/en/temporary-inbox?box=' + prefix + '")');
		menupopup.appendChild(menugo);

		menupopup.appendChild(document.createElement("menuseparator"));
		for (j = 0; j < last_emails[i].used_on.length; j++)
		{
			var menuused = document.createElement("menuitem");
			menuused.setAttribute("label", "Used on: " + last_emails[i].used_on[j]);
			menuused.setAttribute("disabled", true);
			menupopup.appendChild(menuused);
		}
	}
}

window.addEventListener("load", function() {
	mailcatch_regenerate_last();
}, false);

function mailcatch_loadurl(url)
{
	var browser = document.getElementById( "content" );
	var tab = browser.addTab( url, null );
	browser.selectedTab = tab;
}
